//-----------------------------------------------------------------------------
//
// Title       : phase1_tf
// Design      : mips
// Author      : Steven
// Company     : University of Washington CSE
//
//-----------------------------------------------------------------------------
//
// File        : phase1_tf.v
// Generated   : Mon Sep  4 16:29:25 2006
// From        : e:\my_designs\NewLabs\mips378\mips378\mips\src\R_COMPARE\Datapath_TB_settings.txt
// By          : tb_verilog.pl ver. ver 1.2s
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`timescale 1ps / 1ps
module phase1_tf;


//Internal signals declarations:
reg CLK;
reg WriteToRD;
wire Zilch_actual;
reg Zilch;
wire Overflow_actual;
reg Overflow;
wire [31:0]ALUOut_actual;
reg [31:0]ALUOut;
reg [4:0]ALUCtl;
reg RegWrite;
reg [31:0]Inst;
//LOG file declaration.
integer report_file;

//Wait time declaration used in ports monitoring.
//One parameter is declared for every port.
parameter Default_wait_time = 10;
parameter Zilch_WaitTime = Default_wait_time;//WaitTime Parameter for port Zilch
parameter Overflow_WaitTime = Default_wait_time;//WaitTime Parameter for port Overflow
parameter ALUOut_WaitTime = Default_wait_time;//WaitTime Parameter for port ALUOut

//Simulation time
parameter SimulationTime = 64'd1110000 + Default_wait_time + 1;

//Errors counter
integer errors_counter;

//Block of Comparison functions declarations. A separate function for each output port is defined.
//Comparison function for port "Zilch"
function compare_Zilch;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Zilch = 1'b1;
		else compare_Zilch = 1'b0;
	end
endfunction
//Comparison function for port "Overflow"
function compare_Overflow;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Overflow = 1'b1;
		else compare_Overflow = 1'b0;
	end
endfunction
//Comparison function for port "ALUOut"
function compare_ALUOut;
input [31:0] UUT_output;
input [31:0] PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_ALUOut = 1'b1;
		else compare_ALUOut = 1'b0;
	end
endfunction

// Unit Under Test port map
	Datapath UUT (
		.CLK(CLK),
		.WriteToRD(WriteToRD),
		.Zilch(Zilch_actual),
		.Overflow(Overflow_actual),
		.ALUOut(ALUOut_actual),
		.ALUCtl(ALUCtl),
		.RegWrite(RegWrite),
		.Inst(Inst));

initial
	begin
		report_file=$fopen("$DSN\\src\\Tests\\phase1_report.log");
		errors_counter = 0;
		#SimulationTime;
		if (errors_counter)
		begin
			$display("Errors were encountered, differences are listed in phase1_report.log");
			$fdisplay(report_file,"Some vectors failed.");
		end
		else
		begin
			$display("All vectors passed.");
			$fdisplay(report_file,"All vectors passed.");
		end
		$fclose(report_file);
		$finish;
	end

//Below code was generated based on waveform file: "e:\my_designs\NewLabs\mips378\mips378\mips\compile\phase1.vhr"

initial
begin : STIMUL // begin of stimulus process
	#0
	CLK = 1'b0;
	#100
	WriteToRD = 1'b1;
	Overflow = 1'b0;
	Zilch = 1'b0;
	ALUOut = 32'b00000000000000000000000000001001;
	RegWrite = 1'b1;
	ALUCtl = 5'b00010;
	Inst = 32'b00000000100001010100000000100000;
    #349900; //0
	CLK = 1'b1;
	#100
	ALUCtl = 5'b00011;
	Inst = 32'b00000000100001010100100000100001;
    #19900; //350000
	CLK = 1'b0;
    #20000; //370000
	CLK = 1'b1;
	#100
	ALUOut = 32'b11111111111111111111111111111111;
	ALUCtl = 5'b00110;
	Inst = 32'b00000000100001010101000000100010;
    #19900; //390000
	CLK = 1'b0;
    #20000; //410000
	CLK = 1'b1;
	#100
	ALUCtl = 5'b00100;
	Inst = 32'b00000000100001010101100000100011;
    #19900; //430000
	CLK = 1'b0;
    #20000; //450000
	CLK = 1'b1;
	#100
	ALUOut = 32'b00000000000000000000000000000100;
	ALUCtl = 5'b00000;
	Inst = 32'b00000000101001100110000000100100;
    #19900; //470000
	CLK = 1'b0;
    #20000; //490000
	CLK = 1'b1;
	#100
	ALUCtl = 5'b00001;
	ALUOut = 32'b00000000000000000000000000000111;
	Inst = 32'b00000000101001100110100000100101;
    #19900; //510000
	CLK = 1'b0;
    #20000; //530000
	CLK = 1'b1;
	#100
	ALUOut = 32'b00000000000000000000000000000011;
	ALUCtl = 5'b01001;
	Inst = 32'b00000000101001100111000000100110;
    #19900; //550000
	CLK = 1'b0;
    #20000; //570000
	CLK = 1'b1;
	#100
	ALUOut = 32'b11111111111111111111111111111000;
	ALUCtl = 5'b01100;
	Inst = 32'b00000000101001100111100000100111;
    #19900; //590000
	CLK = 1'b0;
    #20000; //610000
	CLK = 1'b1;
	#100
	Zilch = 1'b1;
	ALUOut = 32'b00000000000000000000000000000000;
	ALUCtl = 5'b00111;
	Inst = 32'b00000001001010101100000000101010;
    #19900; //630000
	CLK = 1'b0;
    #20000; //650000
	CLK = 1'b1;
	#100
	Zilch = 1'b0;
	ALUOut = 32'b00000000000000000000000000000001;
	ALUCtl = 5'b01000;
	Inst = 32'b00000001001010101100100000101011;
    #19900; //670000
	CLK = 1'b0;
    #20000; //690000
	CLK = 1'b1;
	#100
	Zilch = 1'b1;
	ALUOut = 32'b00000000000000000000000000000000;
	RegWrite = 1'b0;
	ALUCtl = 5'b10001;
	Inst = 32'b00000011001000000000000000010001;
    #19900; //710000
	CLK = 1'b0;
    #20000; //730000
	CLK = 1'b1;
	#100
	ALUCtl = 5'b10011;
	Inst = 32'b00000011000000000000000000010011;
    #19900; //750000
	CLK = 1'b0;
    #20000; //770000
	CLK = 1'b1;
	#100
	Zilch = 1'b0;
	ALUOut = 32'b00000000000000000000000000000001;
	RegWrite = 1'b1;
	ALUCtl = 5'b10000;
	Inst = 32'b00000000000000001000000000010000;
    #19900; //790000
	CLK = 1'b0;
    #20000; //810000
	CLK = 1'b1;
	#100
	Zilch = 1'b1;
	ALUOut = 32'b00000000000000000000000000000000;
	ALUCtl = 5'b10010;
	Inst = 32'b00000000000000001000100000010010;
    #19900; //830000
	CLK = 1'b0;
    #20000; //850000
	CLK = 1'b1;
	#100
	RegWrite = 1'b0;
	ALUCtl = 5'b01110;
	Inst = 32'b00000001010001010000000000011000;
    #19900; //870000
	CLK = 1'b0;
    #20000; //890000
	CLK = 1'b1;
	#100
	Zilch = 1'b0;
	ALUOut = 32'b11111111111111111111111111111111;
	RegWrite = 1'b1;
	ALUCtl = 5'b10000;
	Inst = 32'b00000000000000001001000000010000;
    #19900; //910000
	CLK = 1'b0;
    #20000; //930000
	CLK = 1'b1;
	#100
	ALUOut = 32'b11111111111111111111111111111011;
	ALUCtl = 5'b10010;
	Inst = 32'b00000000000000001001100000010010;
    #19900; //950000
	CLK = 1'b0;
    #20000; //970000
	CLK = 1'b1;
	#100
	Zilch = 1'b1;
	ALUOut = 32'b00000000000000000000000000000000;
	RegWrite = 1'b0;
	ALUCtl = 5'b01111;
	Inst = 32'b00000001010001010000000000011001;
    #19900; //990000
	CLK = 1'b0;
    #20000; //1010000
	CLK = 1'b1;
	#100
	Zilch = 1'b0;
	ALUOut = 32'b00000000000000000000000000000100;
	RegWrite = 1'b1;
	ALUCtl = 5'b10000;
	Inst = 32'b00000000000000001010000000010000;
    #19900; //1030000
	CLK = 1'b0;
    #20000; //1050000
	CLK = 1'b1;
	#100
	ALUOut = 32'b11111111111111111111111111111011;
	ALUCtl = 5'b10010;
	Inst = 32'b00000000000000001010100000010010;
    #19900; //1070000
	CLK = 1'b0;
    #20000; //1090000
	CLK = 1'b1;
	#100
	WriteToRD = 1'bx;
	Overflow = 1'bx;
	Zilch = 1'b1;
	ALUOut = 32'b00000000000000000000000000000000;
	RegWrite = 1'bx;
	ALUCtl = 5'bXXXXX;
	Inst = 32'bXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX;
end // end of stimulus process
	



//Set of always bloks for ports monitoring.
//One block per output port.
//Always block for monitoring port "Zilch";
always @(Zilch or Zilch_actual)
	begin
		#Zilch_WaitTime
		if (compare_Zilch(Zilch,Zilch_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port Zilch: Expected value is %b, Actual value is %b",Zilch,Zilch_actual);
			$display($realtime,,"ps; Error on port Zilch: Expected value is %b, Actual value is %b",Zilch,Zilch_actual);
		end
	end
//Always block for monitoring port "Overflow";
always @(Overflow or Overflow_actual)
	begin
		#Overflow_WaitTime
		if (compare_Overflow(Overflow,Overflow_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port Overflow: Expected value is %b, Actual value is %b",Overflow,Overflow_actual);
			$display($realtime,,"ps; Error on port Overflow: Expected value is %b, Actual value is %b",Overflow,Overflow_actual);
		end
	end
//Always block for monitoring port "ALUOut";
always @(ALUOut or ALUOut_actual)
	begin
		#ALUOut_WaitTime
		if (compare_ALUOut(ALUOut,ALUOut_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port ALUOut: Expected value is %b, Actual value is %b",ALUOut,ALUOut_actual);
			$display($realtime,,"ps; Error on port ALUOut: Expected value is %b, Actual value is %b",ALUOut,ALUOut_actual);
		end
	end

endmodule
