//--------------------------------------------------------------------------------------------------
//
// Title       : InfoGen
// Design      : success
// Author      : Steven
// Company     : UW CSE
//
//-------------------------------------------------------------------------------------------------
//
// File        : InfoGen.v
// Generated   : Wed May 10 13:10:54 2006
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`timescale 1 ns / 1 ps

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {InfoGen}}
module InfoGen ( IStall,DStall,IF_Stall ,IF_Instr, CLK, RESET );
	
	input wire IF_Stall,DStall,IStall,CLK,RESET ;
	input wire [31:0] IF_Instr ;
	
	//}} End of automatically maintained section
	
	reg [31:0] ID_Instr,EX_Instr,MEM_Instr,WB_Instr;
	//synopsys translate_off
	// -- Enter your statements here -- //
	wire [5:0] IF_opcode,ID_opcode,EX_opcode,MEM_opcode,WB_opcode,ID_FUNC,IF_FUNC,EX_FUNC,MEM_FUNC,WB_FUNC;
	wire [4:0] ID_RS,IF_RS, EX_RS, MEM_RS, WB_RS, ID_RT,IF_RT,EX_RT,MEM_RT,WB_RT;
	wire [15:0] IF,ID,EX,MEM,WB;
	wire Stall = IStall | DStall;
	function [15:0] Translate;
		input [31:0] Inst;
		if(Inst[31:26] == 6'b000000) 
			begin // opcode is 0
				if(Inst != 32'd0)  // disambiguate between sll and nop
					Translate = {2'b00,Inst[5:0],8'h00};
				else
					Translate = {16'h3F00}; // signal that it's a NOP
			end 
		else 
			Translate = {10'd0,Inst[31:26]};
	endfunction
	
	assign {IF_opcode,IF_RS, IF_RT,IF_FUNC} = {IF_Instr[31:16],IF_Instr[5:0]};
	assign {ID_opcode,ID_RS, ID_RT,ID_FUNC} = {ID_Instr[31:16],ID_Instr[5:0]};
	assign {EX_opcode ,EX_RS, EX_RT,EX_FUNC} = {EX_Instr[31:16],EX_Instr[5:0]};
	assign {MEM_opcode ,MEM_RS, MEM_RT,MEM_FUNC} = {MEM_Instr[31:16],MEM_Instr[5:0]};
	assign {WB_opcode ,WB_RS, WB_RT,WB_FUNC} = {WB_Instr[31:16],WB_Instr[5:0]};
	assign IF = Translate(IF_Instr);
	assign ID = Translate(ID_Instr);
	assign EX = Translate(EX_Instr);
	assign MEM = Translate(MEM_Instr);
	assign WB = Translate(WB_Instr);
	
	always @(posedge CLK) begin
			if(RESET) begin
					ID_Instr <= 0;
					EX_Instr <= 0;
					MEM_Instr <= 0;
					WB_Instr <= 0;
			end else begin
					ID_Instr <= (IF_Stall | Stall)? ID_Instr : IF_Instr;
					EX_Instr <= (Stall)? EX_Instr : (IF_Stall)? 32'hFFFFFFFF : ID_Instr;
					MEM_Instr <= (Stall)? MEM_Instr : EX_Instr;
					WB_Instr <= (Stall)? WB_Instr : MEM_Instr;
				end
		end
	
	//synopsys translate_on 
	
	
endmodule
